<cfset categories = application.artservice.getMediaTypes()>

<!DOCTYPE html> 
<html> 
	<head> 
	<meta name="viewport" content="width=device-width, initial-scale=1"> 
	<title>Art Browser</title> 
	<link rel="stylesheet" href="http://code.jquery.com/mobile/1.0b1/jquery.mobile-1.0b1.min.css" />
	<script src="http://code.jquery.com/jquery-1.6.1.min.js"></script>
	<script src="http://code.jquery.com/mobile/1.0b1/jquery.mobile-1.0b1.min.js"></script>
	<script>
	//Credit: http://diveintohtml5.org/storage.html
	function supports_html5_storage() {
	  try {
	    return 'localStorage' in window && window['localStorage'] !== null;
	  } catch (e) {
	    return false;
	  }
	}
	function supports_json() {
	  try {
	    return 'JSON' in window && window['JSON'] !== null;
	  } catch (e) {
	    return false;
	  }
	}
	
	$(document).ready(function() {

		//only bother if we support storage
		if (supports_html5_storage() && supports_json()) {

			//when art detail pages load, show button
			$('div.artDetail').live('pageshow', function(event, ui){
				//which do we show?
				var id = $(this).data("artid");
				if (!hasInStorage(id)) {
					$(".addToFavoritesDiv").show();
					$(".removeFromFavoritesDiv").hide();
				}
				else {
					$(".addToFavoritesDiv").hide();
					$(".removeFromFavoritesDiv").show();
				}
			});

			//When clicking the link in details pages to add to fav
			$(".addToFavoritesDiv a").live('vclick', function(event) {
				var id=$(this).data("artid");
				$.mobile.changePage("addtofav.cfm", {role:"dialog",data:{"id":id}});
			});

			//When clicking the link in details pages to add to fav
			$(".removeFromFavoritesDiv a").live('vclick', function(event) {
				var id=$(this).data("artid");
				$.mobile.changePage("removefromfav.cfm", {role:"dialog",data:{"id":id}});
			});

			//When confirming the add to fav
			$('.addToFavoritesButton').live('vclick', function(event, ui){
				var id=$(this).data("artid");
				var label=$(this).data("artname");
				addToStorage(id,label);
				$("#addToFavoritesDialog").dialog("close");
			});

			//When confirming the remove from fav
			$('.removeFromFavoritesButton').live('vclick', function(event, ui){
				var id=$(this).data("artid");
				var label=$(this).data("artname");
				removeFromStorage(id,label);
				$("#removeFromFavoritesDialog").dialog("close");
			});
			

			$('#homePage').live('pagebeforeshow', function(event, ui){
				//get our favs
				var favs = getStorage();
				var $favoritesList = $("#favoritesList");
				if (!$.isEmptyObject(favs)) {
					if ($favoritesList.size() == 0) {
						$favoritesList = $('<ul id="favoritesList" data-inset="true"></ul>');
						
						var s = "<li data-role=\"list-divider\">Favorites</li>";
						for (var key in favs) {
							s+= "<li><a href=\"art.cfm?id="+key+"\">"+favs[key]+"</a></li>";
						}
						$favoritesList.append(s);
						$("#homePageContent").append($favoritesList);
						$favoritesList.listview();
					} else {
						$favoritesList.empty();
						var s = "<li data-role=\"list-divider\">Favorites</li>";
						for (var key in favs) {
							s+= "<li><a href=\"art.cfm?id="+key+"\">"+favs[key]+"</a></li>";
						}
						$favoritesList.append(s);
						$favoritesList.listview("refresh");
					}
				} else {
					// remove list if it exists and there are no favs
					if($favoritesList.size() > 0) $favoritesList.remove();
				}
			});		
		
			//Adding to storage
			function addToStorage(id,label){
				if (!hasInStorage(id)) {
					var data = getStorage();
					data[id] = label;
					saveStorage(data);
				}
			}	
			
			//loading from storage
			function getStorage(){
				var current = localStorage["favorites"];
				var data = {};
				if(typeof current != "undefined") data=window.JSON.parse(current);
				return data;
			}
			
			//Checking storage
			function hasInStorage(id){
				return (id in getStorage());
			}		

			//Adding to storage
			function removeFromStorage(id,label){
				if (hasInStorage(id)) {
					var data = getStorage();
					delete data[id];
					console.log('removed '+id);
					saveStorage(data);
				}
			}	
			
			//save storage
			function saveStorage(data){
				console.log("To store...");
				console.dir(data);
				localStorage["favorites"] = window.JSON.stringify(data);
			}
	
		}		

	});
	</script>

</head> 
<body> 

<div data-role="page" id="homePage">

	<div data-role="header">
		<h1>Art Browser</h1>
	</div>

	<div data-role="content" id="homePageContent">	
		<ul data-role="listview" data-inset="true">
			<cfoutput query="categories">
				<li><a href="category.cfm?id=#mediaid#&media=#urlEncodedFormat(mediatype)#">#mediatype#</a> <span class="ui-li-count">#total#</span></li>
			</cfoutput>
        </ul>  
						      
	</div>

</div>

</body>
</html>