component {

	public struct function getArtPiece(required numeric id) {
		var q = new com.adobe.coldfusion.query();
        q.setSQL(
			"select a.artid, a.artname, a.description, a.price,
			 a.largeimage, artists.firstname, artists.lastname 
			 from art a left join artists on a.artistid = artists.artistid
			 where a.artid = :artid");        
		q.addParam(name="artid",value=arguments.id,cfsqltype="cf_sql_integer");
		var r = q.execute().getResult();
		var s = {
				id=r.artid, 
				name=r.artname, 
				description=r.description,
				price=r.price,
				image="../artgallery/" & r.largeimage,
				artist=r.firstname & " " & r.lastname
			};
		return s;
	}

	public query function getArt(required numeric mediatype) {
		var q = new com.adobe.coldfusion.query();
        q.setSQL(
			"select artid, artname from art where mediaid = :mediatype");        
		q.addParam(name="mediatype",value=arguments.mediatype,cfsqltype="cf_sql_integer");
        return q.execute().getResult();
		
	}

	public query function getMediaTypes() {
		var q = new com.adobe.coldfusion.query();
        q.setSQL(
			"select m.mediaid, m.mediatype, count(a.artid) as total
			 from media m left join art a on m.mediaid = a.mediaid 
			 group by m.mediaid, m.mediatype
             order by m.mediatype asc");        
        return q.execute().getResult();
	}

}